/**
 * Ouvre une popup
 * 
 * @param title le titre du modal
 * @param newclass la classe à attribuer au bouton valider
 *
 * @return ouvre le popup
 */
function modal(title, newclass){

	// initialiser les buttons
	$('#dialog .btn-primary').removeClass('btn-associate');
	$('#dialog .btn-primary').removeClass('btn-dissociate');
	$('#dialog .btn-primary').removeClass('btn-delete').addClass(newclass);


	$('#dialog').dialog({
		title: title,
		resizable: false,
		closeOnEscape: false,
		height: 'auto',
		minWidth: 320,
		modal: true,	// désactive le mode de recherche de select2
		open: function (e, ui) {
			$(".ui-dialog-titlebar-close", ui.dialog | ui).hide();	// cache la croix fermer

			// active le mode de recherche de select2
			if ($.ui && $.ui.dialog && !$.ui.dialog.prototype._allowInteractionRemapped && $(this).closest(".ui-dialog").length) {
				if ($.ui.dialog.prototype._allowInteraction) {
					$.ui.dialog.prototype._allowInteraction = function (e) {
						if ($(e.target).closest('.select2-drop').length) return true;
						return ui_dialog_interaction.apply(this, arguments);
					};
					$.ui.dialog.prototype._allowInteractionRemapped = true;
				}
				else {
					$.error("You must upgrade jQuery UI or else.");
				}
			}
		},
		_allowInteraction: function (e) {
			return !!$(e.target).is(".select2-input") || this._super(e);
		}
	});
}

function select2(){
	$('.ui-dialog select').select2({
		'language': {
			noResults: function(){
				return 'Aucun résultat trouvé';
			}
		}
	});

	$('.ui-dialog select').on('select2:open', function(e){
		$('#dialog').css('height', 290);
	});

	$('.ui-dialog select').on('select2:close', function(e){
		$('#dialog').css('height', 'auto');
	});
}

function validForm(){
	$('#dialog span.error').empty();

	if($('#classesLdap').val() == 0){
		$('#dialog span.error').empty().append('Veuillez choisir une classe');
		return false;
	}

	return true;
}

/**
 * Retourne la ligne en cours dans le tableau
 * 
 * @param link le lien sur lequel on a cliqué
 *
 * @return renvoi la ligne en cours 
 */
function getRow(link){
	return $(link).parent().parent();	// la ligne en cours
}