<?php
// DIC configuration

$app->container->singleton('pdo', function ($container) {
	$settings = $container['settings'];

	$pdo = NULL;

	try{
		$pdo = new PDO($settings['db.dsn'], $settings['db.username'], $settings['db.password']);
		$pdo->setAttribute(PDO::ATTR_ERRMODE, PDO::ERRMODE_EXCEPTION);
	} catch(PDOException $e){
		echo 'Connexion échouée : ' . $e->getMessage();
	} 

	return $pdo;
});

$app->container->singleton('ldap', function ($container) {
    $settings = $container['settings'];
	return new \Ldap\Ldap($settings);
});

$app->container->singleton('cdt', function ($container) use($app) {
	return new \Cdt\Cdt($app->pdo);
});

$app->container->singleton('base_url', function ($container) use($app) {
	return $container['settings']['base_url'];
});