<?php 

// afficher la liste des classes cdt
$app->get('/', function () use($app) {
	$app->ldap->getCodeClasse($app->cdt->getClassesCdt());

	$app->render('index.php', 
		array(
			'classesCdt' => $app->cdt->getClassesCdt(),
			'base_url' => $app->base_url
			)
		);
});


// associer une classe cdt à une classe de l'annuaire
$app->get('/associate/:code_classe/:id_classe', function ($code_classe, $id_classe) use($app) {
	$classesLdap = array();
	$allClassesLdap = $app->ldap->getClassesLdap();

	foreach ($allClassesLdap['cn'] as $value) {
		array_push($classesLdap, $value);
	}

	$app->render('edit.php', 
		array(
			'id_classe' => $id_classe,
			'code_classe' => $code_classe,
			'classesLdap' => $classesLdap,
			)
		);
});
$app->post('/associate/:code_classe/:id_classe', function ($code_classe, $id_classe) use($app) {
	$app->cdt->associate($code_classe, $id_classe);
});

// synchronisation des classes cdt avec celle de l'annuaire
$app->get('/synchro', function () use($app) {
	// affectation auto
	// met à jour le code_classe des classes cdt présentes dans ldap
	$updateCdt = $app->cdt->updateCdt($app->ldap->getCodeClasse($app->cdt->getClassesCdt()));

	// ajouter dans cdt les classes ldap qui n'existent pas cdt
	$synchro = $app->cdt->synchro($app->ldap->getClassesLdap());

	$error = ($synchro && $updateCdt) ? true : false;

	$app->render('synchro.php', 
		array(
			'error'=> $error,
			'base_url' => $app->base_url
			)
		);
});


// supprimer une  classe cdt
$app->post('/delete/:id_classe', function ($id_classe) use($app) {
	$app->cdt->delete($id_classe);
});


// dissocier une classe cdt d'une classe de l'annuaire
$app->post('/dissociate/:id_classe', function ($id_classe) use($app) {
	$app->cdt->dissociate($id_classe);
});


$app->notFound(function () use ($app) {
    $app->render('404.html');
});